import os
import json

SUCCESS_EXITCODE = 0
ERROR_EXITCODE = 1

ROOT_DIRECTORY = os.path.join(os.path.expanduser('~'), '.abeja')
CONFIG_FILE_PATH = os.path.join(ROOT_DIRECTORY, 'config')
LOG_DIRECTORY = os.path.join(os.path.expanduser('~'), '.abeja', 'log')
LOG_FILE_PATH = os.path.join(LOG_DIRECTORY, 'abejacli.log')

PLATFORM_BASE_URL = os.environ.get('PLATFORM_BASE_URL', 'https://api.abeja.io')
CONFIG = None
ABEJA_PLATFORM_USER_ID = None
ABEJA_PLATFORM_TOKEN = None
ORGANIZATION_NAME = None
ORGANIZATION_ENDPOINT = None
SAMPLE_MODEL_PATH = os.environ.get(
    'SAMPLE_MODEL_PATH',
    'https://s3-ap-northeast-1.amazonaws.com/abeja-platform-config-prod'
)
STDERROR_LOG_LEVEL = os.environ.get('LOG_LEVEL', 'ERROR')
DATALAKE_ITEMS_PER_PAGE = os.environ.get('DATALAKE_ITEMS_PER_PAGE', 100)
HTTP_READ_CHUNK_SIZE = os.environ.get('HTTP_READ_CHUNK_SIZE', 1024)
FILE_READ_CHUNK_SIZE = os.environ.get('FILE_READ_CHUNK_SIZE', 8192)
JOB_WORKER_THREAD_NUM = os.environ.get('JOB_WORKER_THREAD_NUM', 5)


if os.path.exists(CONFIG_FILE_PATH):
    with open(CONFIG_FILE_PATH, 'r') as f:
        CONFIG = json.load(f)
    ABEJA_PLATFORM_USER_ID = os.environ.get('ABEJA_PLATFORM_USER', CONFIG['abeja-platform-user'])
    ABEJA_PLATFORM_TOKEN = os.environ.get('PERSONAL_ACCESS_TOKEN', CONFIG['personal-access-token'])
    ORGANIZATION_NAME = os.environ.get('ORGANIZATION_NAME', CONFIG['organization-name'])

ORGANIZATION_ENDPOINT = "{}/organizations/{}".format(PLATFORM_BASE_URL, ORGANIZATION_NAME)
protocol, fqdn = PLATFORM_BASE_URL.split('://')
WEB_API_ENDPOINT = '{}://{}.{}'.format(protocol, ORGANIZATION_NAME, fqdn)
